/*********************************************
 * Benjamin Krill <ben@codiert.org>
 *********************************************/
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include "fpgafs.h"

static int fpgafs_send_data_cham(unsigned char *buf, int len)
{
	printk("fpgafs: send data CHAM\n");
	return 0;
}

static int fpgafs_recv_data_cham(unsigned char *buf, int len)
{
	printk("fpgafs: receive data CHAM\n");
	return 4;
}

static struct fpgafs_lldrv fpgafs_lldrv_cham = {
	.name = "cham",
	.init = NULL,
	.exit = NULL,
	.send = &fpgafs_send_data_cham,
	.recv = &fpgafs_recv_data_cham
};

/* init exit functions ... */
int __init fpgafs_lldrv_cham_init(void)
{
	return fpgafs_register_lldrv(&fpgafs_lldrv_cham);
}

void __exit fpgafs_lldrv_cham_exit(void)
{
	fpgafs_unregister_lldrv(&fpgafs_lldrv_cham);
}

module_init(fpgafs_lldrv_cham_init);
module_exit(fpgafs_lldrv_cham_exit);

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Benjamin Krill <ben@codiert.org>");
