/*********************************************
 * Benjamin Krill <ben@codiert.org>
 *********************************************/
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include "fpgafs.h"

static int fpgafs_send_data_dbg(unsigned char *buf, int len)
{
	printk("fpgafs: send data DEBUG\n");
	return 0;
}

static int fpgafs_recv_data_dbg(unsigned char *buf, int len)
{
	printk("fpgafs: receive data DEBUG\n");
	return 4;
}

static struct fpgafs_lldrv fpgafs_lldrv_dbg = {
	.name = "dbg",
	.init = NULL,
	.exit = NULL,
	.send = &fpgafs_send_data_dbg,
	.recv = &fpgafs_recv_data_dbg
};

/* init exit functions ... */
int __init fpgafs_lldrv_dbg_init(void)
{
	return fpgafs_register_lldrv(&fpgafs_lldrv_dbg);
}

void __exit fpgafs_lldrv_dbg_exit(void)
{
	fpgafs_unregister_lldrv(&fpgafs_lldrv_dbg);
}

module_init(fpgafs_lldrv_dbg_init);
module_exit(fpgafs_lldrv_dbg_exit);

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Benjamin Krill <ben@codiert.org>");
